// IECachePurge.h - En-tte des types et variables communs de la purge le cache Internet Explorer 5.x, 6.0 de tous les fichiers inutiles.
// Copyright (c) 2001, 2005, Thierry MARTIN.
// Version #1.10.
// Cre le jeudi 1 juin 2005.

// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
// les termes de la Licence Publique Gnrale GNU publie par la Free Software
// Foundation (version 2 ou bien toute autre version ultrieure choisie par
// vous).
//
// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
// GARANTIE, ni explicite ni implicite, y compris les garanties de
// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
//
// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
// temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// tats-Unis.

// Vous pouvez me joindre par e-mail  : iecachepurge@martin-thierry.nom.fr

// Versions :
//	  #1.00 : 01/08/01 : Mode console, affiche les fichier inutiles ou supprime ces fichiers suivant l'option donne lors de
//								l'appel.
//	  #1.01 : 14/10/01 : Ajout d'une interface graphique avec wxwindows.
//	  #1.10 : 01/06/05 : Sparation de l'interface graphique et de l'application. Cration d'une option pour lancer la purge automatiquement.
//
// J'ai dvelopp ce programme en utilisant les outils suivants :
//   Compilateur GCC version 3.3.3 avec l'environnement CygWin32 version 1.5.17 disponible  http://www.cygwin.com/
//   Bibliotque graphique C++ wxWidgets version 2.6.0 disponible  http://www.wxwidgets.org/

class TCacheIEAPurger
{
public:
	virtual void AjoutDossier (const wxString& nom_) = 0;
	virtual void AjoutFichier (const wxString& nom_) = 0;
	virtual wxString PremierFichier () = 0;
	virtual bool SupprimeFichier (const wxString& nom_) = 0;
	virtual ~TCacheIEAPurger ();
};

class TDossierCache
{
public:
	wxString m_dossier;
	wxArrayString m_fichiers;

	TDossierCache ();
	TDossierCache (const wxString& nomDossier_);
	TDossierCache (const TDossierCache& origine_);
	TDossierCache& operator = (const TDossierCache& origine_);
	~TDossierCache ();
};

WX_DECLARE_OBJARRAY(TDossierCache, TArrayDossiersCache);

class TTableauCacheIEAPurger : public TCacheIEAPurger
{
private:
	TArrayDossiersCache m_dossiers;
public:
	virtual void AjoutDossier (const wxString& nom_);
	virtual void AjoutFichier (const wxString& nom_);
	virtual wxString PremierFichier ();
	virtual bool SupprimeFichier (const wxString& nom_);
	virtual ~TTableauCacheIEAPurger ();
};

struct _INTERNET_CACHE_ENTRY_INFOA;
typedef _INTERNET_CACHE_ENTRY_INFOA INTERNET_CACHE_ENTRY_INFOA;
typedef INTERNET_CACHE_ENTRY_INFOA INTERNET_CACHE_ENTRY_INFO;
class TContenuCacheIE;
class TInfoRecherche;

class TEnsembleCacheIE
{
private:
	enum EtatRecherche
	{
		erInitialise,
		erCache,
		erDossier,
		erFichier,
		erTermine,
		erErreur
	};

	TCacheIEAPurger& m_aPurger;
	TContenuCacheIE* m_contenuCache;
	EtatRecherche	  m_etatRecherche;
	TInfoRecherche*  m_infoRecherche;
	wxString			  m_messageErreur;
	unsigned int	  m_nombreFichiers;
	wxFileOffset	  m_tailleTotale;

	void AjouteCache (INTERNET_CACHE_ENTRY_INFO* cacheInfo_);
	bool RecherchePremierFichier ();
	bool TraiteFichierTrouve ();
public:
	TEnsembleCacheIE (TCacheIEAPurger& aPurger_);
	~TEnsembleCacheIE ();
	const wxString& Erreur () {return m_messageErreur;};
	unsigned int NombreFichiers () {return m_nombreFichiers;};
	bool RechercheSuivant ();
	bool PurgeSuivant ();
	wxFileOffset TailleTotale () {return m_tailleTotale;};
};

extern wxString g_nomDossierTIF;

// vim:ts=3:sw=3:
