// IECachePurgeApp.cpp - Partie purement applicative de la purge le cache Internet Explorer 5.x, 6.0 de tous les fichiers inutiles.
// Copyright (c) 2001, 2005, Thierry MARTIN.
// Version #1.10.
// Cre le dimanche 5 juin 2005.

// Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
// les termes de la Licence Publique Gnrale GNU publie par la Free Software
// Foundation (version 2 ou bien toute autre version ultrieure choisie par
// vous).
//
// Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
// GARANTIE, ni explicite ni implicite, y compris les garanties de
// commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
// Licence Publique Gnrale GNU pour plus de dtails.
//
// Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
// temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
// tats-Unis.

// Vous pouvez me joindre par e-mail  : iecachepurge@martin-thierry.nom.fr

// Versions : voir le fichier IECachePurge.h

#include <wx/wx.h>
#include <wx/msw/registry.h>
#include <wx/progdlg.h>
#include <wx/imaglist.h>
#include <wx/treectrl.h>
#include <wx/file.h>
#include <Windows.H>
#include <WinINet.H>
#include <IOStream.H>

#include "IECachePurge.h"

// Dclaration des classes

class TContenuCacheIE
{
private:
	class TFichierTIF
	{
	private:
		wxString m_nomFichier;
		TFichierTIF* m_precedent;
		TFichierTIF* m_suivant;

		TFichierTIF (const wxString& nouvNom_)
		 : m_nomFichier (nouvNom_) ,m_precedent (NULL), m_suivant (NULL)
		{
		}
		~TFichierTIF ()
		{
			delete m_precedent;
			delete m_suivant;
		}
		friend class TContenuCacheIE;
	};

	TFichierTIF* m_premier;

	TFichierTIF* Trouver (const wxString& nomFichier_, bool ajout_);
public:
	TContenuCacheIE ()
	 : m_premier (NULL)
	{
	}
	~TContenuCacheIE ()
	{
		delete m_premier;
	}
	void Ajouter (const wxString& nouvNom_)
	{
		Trouver (nouvNom_, TRUE);
	}
	bool Present (const wxString& nomCherche_)
	{
		return Trouver (nomCherche_, FALSE) != NULL;
	}
};

// Variables

wxString g_nomDossierTIF;

// Dfinition des tableaux

#include <wx/arrimpl.cpp>
WX_DEFINE_OBJARRAY(TArrayDossiersCache);

// Dfinition des fonctions membres TContenuCacheIE

TContenuCacheIE::TFichierTIF* TContenuCacheIE::Trouver (const wxString& nomFichier_, bool ajout_)
{
	TContenuCacheIE::TFichierTIF** reference = &m_premier;

	if (m_premier)
	{
		TContenuCacheIE::TFichierTIF* courant;
		for (courant = m_premier ; courant ; courant = *reference)
		{
			if (nomFichier_ == courant->m_nomFichier) return courant;
			reference = (nomFichier_ < courant->m_nomFichier) ? (&courant->m_precedent) : (&courant->m_suivant);
		}
	}
	if (ajout_)
	{
		TContenuCacheIE::TFichierTIF* nouveau = new TContenuCacheIE::TFichierTIF (nomFichier_);
		*reference = nouveau;
		return nouveau;
	}
	return NULL;
}

// Dfinition des fonctions membres de TCacheIEAPurger

TCacheIEAPurger::~TCacheIEAPurger ()
{
}

// Dfinition des fonctions membres de TDossierCache

TDossierCache::TDossierCache ()
{
}

TDossierCache::TDossierCache (const wxString& nomDossier_)
 : m_dossier (nomDossier_)
{
}

TDossierCache::TDossierCache (const TDossierCache& origine_)
 : m_dossier (origine_.m_dossier), m_fichiers (origine_.m_fichiers)
{
}

TDossierCache& TDossierCache::operator = (const TDossierCache& origine_)
{
	m_dossier = origine_.m_dossier;
	m_fichiers = origine_.m_fichiers;
	return *this;
}

TDossierCache::~TDossierCache ()
{
}

// Dfinition des fonctions membres de TEnsembleCacheIE et des classes TInfoRecherche...

class TInfoRecherche
{
public:
	virtual ~TInfoRecherche ();
};

TInfoRecherche::~TInfoRecherche ()
{
}

class TInfoRechercheCache : public TInfoRecherche
{
public:
	HANDLE cache;
	DWORD tailleInfo;
	LPINTERNET_CACHE_ENTRY_INFO cacheInfo;

	TInfoRechercheCache () : tailleInfo (0), cacheInfo (NULL) {};
	virtual ~TInfoRechercheCache ();
};

TInfoRechercheCache::~TInfoRechercheCache ()
{
	if (cache != NULL) FindCloseUrlCache (cache);
	if (cacheInfo) delete cacheInfo;
}

struct TInfoRechercheDossier : public TInfoRecherche
{
	WIN32_FIND_DATA dossierTrouve;
	WIN32_FIND_DATA fichierTrouve;
	bool nouveauDossier;
	HANDLE rechercheDossiers;
	HANDLE rechercheFichiers;
	wxString sousDossier;

	TInfoRechercheDossier () : rechercheDossiers (INVALID_HANDLE_VALUE), rechercheFichiers (INVALID_HANDLE_VALUE) {};
	virtual ~TInfoRechercheDossier ();
};

TInfoRechercheDossier::~TInfoRechercheDossier ()
{
	if (rechercheDossiers != INVALID_HANDLE_VALUE) FindClose (rechercheDossiers);
	if (rechercheFichiers != INVALID_HANDLE_VALUE) FindClose (rechercheFichiers);
}

void TEnsembleCacheIE::AjouteCache (INTERNET_CACHE_ENTRY_INFO* cacheInfo_)
{
	wxString nomURL (cacheInfo_->lpszSourceUrlName);

	if (!nomURL.StartsWith ("Cookie:") && !nomURL.StartsWith ("Visited:") && cacheInfo_->lpszLocalFileName)
	{
		m_contenuCache->Ajouter (cacheInfo_->lpszLocalFileName);
	}
}

bool TEnsembleCacheIE::RecherchePremierFichier ()
{
	TInfoRechercheDossier* infoRechercheDossier = (TInfoRechercheDossier*) m_infoRecherche;
	WIN32_FIND_DATA& dossierTrouve = infoRechercheDossier->dossierTrouve;

	if ((dossierTrouve.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0 &&
		 strcmp (dossierTrouve.cFileName, ".") != 0 && strcmp (dossierTrouve.cFileName, "..") != 0)
	{
		wxString sousDossierRecherche;

		infoRechercheDossier->sousDossier = g_nomDossierTIF + dossierTrouve.cFileName;
		sousDossierRecherche = infoRechercheDossier->sousDossier + "\\*";
		if (sousDossierRecherche.Len () >= MAX_PATH)
		{
			m_messageErreur = wxString::Format ("Le nom du dossier \"%s\" est trop long pour tre parcouru.\n"
															"Recherche abandonne.\n", infoRechercheDossier->sousDossier.c_str ());
			return false;
		}

		infoRechercheDossier->rechercheFichiers = FindFirstFile (sousDossierRecherche, &infoRechercheDossier->fichierTrouve);
		if (infoRechercheDossier->rechercheFichiers == INVALID_HANDLE_VALUE)
		{
			DWORD erreur = GetLastError ();

			m_messageErreur = wxString::Format ("Erreur numro %ld au dbut de la recherche des fichiers\n"
															"contenus dans \"%s\".\n"
															"Recherche abandonne.\n", erreur, infoRechercheDossier->sousDossier.c_str ());
			return false;
		}
		infoRechercheDossier->nouveauDossier = TRUE;
		m_etatRecherche = erFichier;
		return TraiteFichierTrouve ();
	}
	return true;
}

bool TEnsembleCacheIE::RechercheSuivant ()
{
	switch (m_etatRecherche)
	{
	case erInitialise:
	{
		if (m_contenuCache) delete m_contenuCache;
		m_contenuCache = new TContenuCacheIE ();

		TInfoRechercheCache* infoRechercheCache = (TInfoRechercheCache*) m_infoRecherche;

		m_infoRecherche = infoRechercheCache = new TInfoRechercheCache;
		while ((infoRechercheCache->cache = FindFirstUrlCacheEntry (NULL, infoRechercheCache->cacheInfo, &infoRechercheCache->tailleInfo)) == NULL)
		{
			DWORD erreur = GetLastError ();

			if (erreur != ERROR_INSUFFICIENT_BUFFER)
			{
				m_etatRecherche = erErreur;
				m_messageErreur = wxString::Format ("Erreur numro %ld aprs l'appel de FindFirstUrlCacheEntry.\n"
															 "Aucune recherche n'est effectue.\n", erreur);
				return false;
			}
			infoRechercheCache->cacheInfo = LPINTERNET_CACHE_ENTRY_INFO (new char [infoRechercheCache->tailleInfo]);
		}
		AjouteCache (infoRechercheCache->cacheInfo);
		m_etatRecherche = erCache;
		break;
	}
	case erCache:
	{
		TInfoRechercheCache* infoRechercheCache = (TInfoRechercheCache*) m_infoRecherche;

		while (!FindNextUrlCacheEntry (infoRechercheCache->cache, infoRechercheCache->cacheInfo, &infoRechercheCache->tailleInfo))
		{
			DWORD erreur = GetLastError ();

			if (erreur == ERROR_NO_MORE_ITEMS)
			{
				TInfoRechercheDossier* infoRechercheDossier;

				delete m_infoRecherche;
				m_etatRecherche = erDossier;
				m_infoRecherche = infoRechercheDossier = new TInfoRechercheDossier;

				wxString nomDossierRecherche = g_nomDossierTIF + '*';

				if (nomDossierRecherche.Len () >= MAX_PATH)
				{
					m_etatRecherche = erErreur;
					m_messageErreur = wxString::Format ("Le nom du dossier \"%s\" est trop long pour tre parcouru.\n"
																	"Recherche abandonne.\n", (const char*) nomDossierRecherche);
					return false;
				}
				infoRechercheDossier->rechercheDossiers = FindFirstFile (nomDossierRecherche, &infoRechercheDossier->dossierTrouve);
				if (infoRechercheDossier->rechercheDossiers == INVALID_HANDLE_VALUE)
				{
					DWORD erreur = GetLastError ();

					m_etatRecherche = erErreur;
					m_messageErreur = wxString::Format ("Erreur numro %ld au dbut de la recherche des dossiers\n"
																	"contenus dans \"%s\"."
																	"Recherche abandonne.\n", erreur, (const char*) g_nomDossierTIF);
					return false;
				}
				return RecherchePremierFichier ();
			}
			if (erreur != ERROR_INSUFFICIENT_BUFFER)
			{
				m_etatRecherche = erErreur;
				m_messageErreur = wxString::Format ("Erreur numro %ld aprs l'appel de FindNextUrlCacheEntry.\n"
																"Recherche abandonne.\n", erreur);
				return false;
			}
			if (infoRechercheCache->cacheInfo) delete infoRechercheCache->cacheInfo;
			infoRechercheCache->cacheInfo = LPINTERNET_CACHE_ENTRY_INFO (new char [infoRechercheCache->tailleInfo]);
		}
		AjouteCache (infoRechercheCache->cacheInfo);
		break;
	}
	case erDossier:
		{
			TInfoRechercheDossier* infoRechercheDossier = (TInfoRechercheDossier*) m_infoRecherche;

			if (!FindNextFile (infoRechercheDossier->rechercheDossiers, &infoRechercheDossier->dossierTrouve))
			{
				DWORD erreur = GetLastError ();

				if (erreur != ERROR_NO_MORE_FILES)
				{
					m_etatRecherche = erErreur;
					m_messageErreur = wxString::Format ("Erreur numro %ld lors de la recherche suivante des dossiers\n"
																	"contenus dans \"%s\".\n"
																	"Recherche abandonne.\n", erreur, (const char*) g_nomDossierTIF);
					return false;
				}
				m_etatRecherche = erTermine;
				if (m_contenuCache)
				{
					delete m_contenuCache;
					m_contenuCache = NULL;
				}
				if (m_infoRecherche)
				{
					delete m_infoRecherche;
					m_infoRecherche = NULL;
				}
				return false;
			}
			return RecherchePremierFichier ();
		}
	case erFichier:
		{
			TInfoRechercheDossier* infoRechercheDossier = (TInfoRechercheDossier*) m_infoRecherche;

			if (!FindNextFile (infoRechercheDossier->rechercheFichiers, &infoRechercheDossier->fichierTrouve))
			{
				DWORD erreur = GetLastError ();

				if (erreur != ERROR_NO_MORE_FILES)
				{
					m_messageErreur = wxString::Format ("Erreur numro %ld lors de la recherche suivante des fichiers\n"
																	"contenus dans \"%s\".\n"
																	"Recherche abandonne.\n", erreur, infoRechercheDossier->sousDossier.c_str ());
					return false;
				}
				m_etatRecherche = erDossier;
				FindClose (infoRechercheDossier->rechercheFichiers); infoRechercheDossier->rechercheFichiers = INVALID_HANDLE_VALUE;
				break;
			}
			return TraiteFichierTrouve ();
		}
	default:
		m_etatRecherche = erErreur;
		m_messageErreur = wxString::Format ("Impossible de poursuivre la recherche des fichiers avec l'tat de recherche %d", m_etatRecherche);
		return false;
	}
	return true;
}

bool TEnsembleCacheIE::TraiteFichierTrouve ()
{
	TInfoRechercheDossier* infoRechercheDossier = (TInfoRechercheDossier*) m_infoRecherche;
	WIN32_FIND_DATA& fichierTrouve = infoRechercheDossier->fichierTrouve;

	if ((fichierTrouve.dwFileAttributes & (FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_DIRECTORY)) == 0)
	{
		wxString nomFichier = infoRechercheDossier->sousDossier + '\\' + fichierTrouve.cFileName;

		if (!m_contenuCache->Present (nomFichier))
		{
			wxLogNull logNull;
			wxFile fichier (nomFichier);

			if (fichier.IsOpened ())
			{
				if (infoRechercheDossier->nouveauDossier)
				{
					m_aPurger.AjoutDossier (infoRechercheDossier->dossierTrouve.cFileName);
					infoRechercheDossier->nouveauDossier = false;
				}
				m_aPurger.AjoutFichier (fichierTrouve.cFileName);
				++m_nombreFichiers;
			  	m_tailleTotale += fichier.Length ();
			}
		}
	}
	return true;
}

bool TEnsembleCacheIE::PurgeSuivant ()
{
	wxString nomFichier = m_aPurger.PremierFichier ();
	if (nomFichier.IsEmpty ())
		return false;
	if (!wxRemoveFile (g_nomDossierTIF + nomFichier))
	{
		m_messageErreur = "Tous les fichier n'ont pas t supprims.";
	}
	if (!m_aPurger.SupprimeFichier (nomFichier))
	{
		m_messageErreur = "Impossible de supprimer le fichier \"" + nomFichier + "\" de la liste des fichiers inutiles.";
		return false;
	}
	return true;
}

TEnsembleCacheIE::TEnsembleCacheIE (TCacheIEAPurger& aPurger_)
 : m_aPurger (aPurger_), m_contenuCache (NULL), m_etatRecherche (erInitialise), m_infoRecherche (NULL), m_nombreFichiers (0), m_tailleTotale (0)
{
	if (g_nomDossierTIF.IsEmpty ())
	{
		wxRegKey rkTIFPaths (wxRegKey::HKLM, "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings\\Cache\\Paths");
		if (!rkTIFPaths.Open ())
		{
			m_messageErreur = "Il n'est pas possible de trouver dans la base de registre\n"
								 "la cl contenant le nom du dossier Temporary Internet Files.";
			return;
		}
		if (!rkTIFPaths.QueryValue ("Directory", g_nomDossierTIF) || g_nomDossierTIF.IsEmpty ())
		{
			m_messageErreur = "Il n'est pas possible de trouver dans la base de registre\n"
								 "la variable contenant le nom du dossier Temporary Internet Files.";
			return;
		}
		if (g_nomDossierTIF.Last () != '\\')
		{
			if (g_nomDossierTIF.Len () + 1 >= MAX_PATH)
			{
				m_messageErreur = "Le nom du dossier \"" + g_nomDossierTIF + "\" est trop long pour tre parcouru.";
				return;
			}
			g_nomDossierTIF += '\\';
		}
	}
}

TEnsembleCacheIE::~TEnsembleCacheIE ()
{
	if (m_contenuCache) delete m_contenuCache;
	if (m_infoRecherche) delete m_infoRecherche;
}

// Dfinition des fonctions membre de TTAbleauCacheIEAPurger

void TTableauCacheIEAPurger::AjoutDossier (const wxString& nom_)
{
	TDossierCache* nouveauDossier = new TDossierCache (nom_);

	m_dossiers.Add (nouveauDossier);
}

void TTableauCacheIEAPurger::AjoutFichier (const wxString& nom_)
{
	m_dossiers.Last ().m_fichiers.Add (nom_);
}

wxString TTableauCacheIEAPurger::PremierFichier ()
{
	if (m_dossiers.GetCount () == 0)
		return "";
	TDossierCache dernier = m_dossiers.Item (0);
	return dernier.m_dossier + "\\" + dernier.m_fichiers.Item (0);
}

bool TTableauCacheIEAPurger::SupprimeFichier (const wxString& nom_)
{
	int position = nom_.Find ('\\');

	if (position == -1) return false;

	wxString nomDossier = nom_.Left (position);
	wxString nomFichier = nom_.Mid (position + 1);
	int nombreDossiers = m_dossiers.GetCount ();
	int dossierId = 0;

	for (;;)
	{
		if (dossierId == nombreDossiers) return false;
		if (m_dossiers.Item (dossierId).m_dossier == nomDossier)
			break;
		++dossierId;
	}

	TDossierCache& dossier = m_dossiers.Item (dossierId);
	int nombreFichiers = dossier.m_fichiers.GetCount ();
	int fichierId = 0;

	for (;;)
	{
		if (fichierId == nombreFichiers) return false;
		if (dossier.m_fichiers.Item (fichierId) == nomFichier)
			break;
		++fichierId;
	}
	dossier.m_fichiers.RemoveAt (fichierId);
	if (dossier.m_fichiers.GetCount () == 0)
		m_dossiers.RemoveAt (dossierId);
	return true;
}

TTableauCacheIEAPurger::~TTableauCacheIEAPurger ()
{
}

// vim:ts=3:sw=3:
